SystemOrganization addCategory: #'Magritte-Tools'!

ORSwapMethodRefactoring subclass: #MAMagritteMethodRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tools'!

!MAMagritteMethodRefactoring class methodsFor: 'as yet unclassified' stamp: 'NickAger 1/13/2012 10:42'!
performFor: aClass
	aClass class allSelectors select: #isDescriptionSelector thenDo: [ :each |
		| refactoring |
		refactoring := self model: nil swapMethod: each in: aClass class.
		refactoring execute ]! !

!MAMagritteMethodRefactoring class methodsFor: 'as yet unclassified' stamp: 'NickAger 1/12/2012 22:21'!
performForAllClasses
	Object allSubclasses do: [ :aClass | 
		(aClass class allSelectors detect: #isDescriptionSelector ifNone: [ nil ]) notNil ifTrue: [
			self performFor: aClass ] ]! !

!MAMagritteMethodRefactoring methodsFor: 'private' stamp: 'NickAger 1/13/2012 20:53'!
alreadyIncludesMagritteSelectors: parseTree
	^ (parseTree pragmas detect: [ :each | MAPragmaBuilder magritteSelectors includes: each selector ] ifNone: [ nil ]) notNil! !

!MAMagritteMethodRefactoring methodsFor: 'private' stamp: 'NickAger 1/13/2012 21:07'!
createPragma: parseTree
	((selector = #descriptionContainer) or: [ selector isDescriptionExtension: #descriptionContainer ]) ifTrue: [
		^ RBPragmaNode selectorParts: (Array with: MAPragmaBuilder containerPragma) arguments: #() ].
	
	(selector isDescriptionDefinition) ifTrue: [
		^ RBPragmaNode selectorParts: (Array with: MAPragmaBuilder descriptionPragma) arguments: #() ].
	
	((selector isDescriptionSelector) and: [ selector numArgs = 1 ]) ifTrue: [
		| descriptionDefinitionSelector |
		
		descriptionDefinitionSelector := class allSelectors detect: [ :each | 
			each isDescriptionDefinition and: [ selector isDescriptionExtension: each ] ] ifNone: [ nil ].
		
		descriptionDefinitionSelector isNil ifTrue: [
			descriptionDefinitionSelector := class soleInstance allSelectors detect: [ :each | 
				each isDescriptionDefinition and: [ selector isDescriptionExtension: each ] ] ifNone: [ nil ] ].
		
		descriptionDefinitionSelector notNil ifTrue: [
			^ RBPragmaNode selectorParts: (Array with: MAPragmaBuilder descriptionExtensionPragma) arguments: (Array with: (RBLiteralValueNode literalToken: descriptionDefinitionSelector))] ].
	^ nil
! !

!MAMagritteMethodRefactoring methodsFor: 'preconditions' stamp: 'NickAger 1/13/2012 17:56'!
preconditions
	^ RBCondition withBlock: [ selector isDescriptionSelector ]! !

!MAMagritteMethodRefactoring methodsFor: 'transforming' stamp: 'NickAger 1/13/2012 21:06'!
transform
	| parseTree methodBody |

	parseTree := class parseTreeFor: selector.
	
	(self alreadyIncludesMagritteSelectors: parseTree) ifFalse: [
		| pragma |
		pragma := self createPragma: parseTree.
		pragma notNil ifTrue: [
			parseTree pragmas: (parseTree pragmas, (Array with: pragma)) ] ].
		
	methodBody := class methodFor: selector.
	target compile: (parseTree formattedCode) classified: 'magritte-descriptions'.
	class removeMethod: selector! !

RBClassRefactoring subclass: #MAMagritteClassRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tools'!

!MAMagritteClassRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/14/2012 09:38'!
preconditions
	^ RBCondition empty! !

!MAMagritteClassRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/14/2012 10:59'!
refactorings
	| class |
	class := self classObjectFor: className asSymbol.
	class := class isMeta ifFalse: [ class theMetaClass ] ifTrue: [ class ].
	^ class allSelectors select: #isDescriptionSelector thenCollect: [ :each |
			MAMagritteMethodRefactoring
				model: self model
				swapMethod: each
				in: class ]! !

!MAMagritteClassRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/14/2012 10:53'!
transform
	self refactorings do: [ :each | self performComponentRefactoring: each ]! !

ORCmdClassRefactoring subclass: #ORCmdMAMagritteClassRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tools'!

!ORCmdMAMagritteClassRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/14/2012 00:03'!
label
	^ 'Update Magritte description'! !

!ORCmdMAMagritteClassRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/14/2012 00:04'!
longDescription
	^ 'Move Magritte description to instance side and add a pragma.'! !

!ORCmdMAMagritteClassRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/14/2012 00:20'!
refactoring
	^ MAMagritteClassRefactoring model: self model className: self currentNode theClass name! !

ORCmdMethodRefactoring subclass: #ORCmdMAMoveDescriptionsToInstanceRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tools'!

!ORCmdMAMoveDescriptionsToInstanceRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/13/2012 17:56'!
label
	^ 'Update Magritte description'! !

!ORCmdMAMoveDescriptionsToInstanceRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/13/2012 18:07'!
longDescription
	^ 'Move Magritte description to instance side and add a pragma.'! !

!ORCmdMAMoveDescriptionsToInstanceRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/14/2012 00:10'!
refactoring
	^ MAMagritteMethodRefactoring
		model: self model
		swapMethod: self currentNode selector
		in: self currentNode theClass! !
